var hexArrWithSpaceRegex = /^[a-f 0-9]*$/i;
var hexArrWithoutSpaceRegex = /^[a-f0-9]*$/i;

var positiveIntRegex = /^[0-9]*$/i;

function copy(obj) {
 var copyObj;

 if(typeof obj === 'object') {

   if(isNaN(obj.length)) {
     copyObj = {};
     for(var each in obj) {
       if(typeof obj[each] === 'object') {
         copyObj[each] = copy(obj[each]);
       } else {
         copyObj[each] = obj[each];
       }
     }
   } else {
     copyObj = [];
     for(var i=0; i<obj.length; i++) {
       if(typeof obj[i] === 'object') {
         copyObj[i] = copy(obj[i]);
       } else {
         copyObj[i] = obj[i];
       }
     }
   }

   return copyObj;
 }

 return obj;
}

function prependZero(input, length) {
  while(input.length < length) {
      input = '0' + input;
  }
  return input;
}

function getDateAndTime(dateAndTime) {
  var year = dateAndTime.getFullYear();
  var month = prependZero((dateAndTime.getMonth() + 1).toString(), 2);
  var date = prependZero(dateAndTime.getDate().toString(), 2);

  return year + '-' + month + '-' + date + ' ' + dateAndTime.toLocaleTimeString().replace(/:/g, '-');
}

function validateJSON(obj) {
  try {
    JSON.parse(obj);
    return true;
  } catch(e) {
    return false;
  }
}

/*
 *  Command Sequence
 */

function getSeqFileValidity(sequence) {
  return typeof sequence.path === 'string' && sequence.path.length > 0 && typeof sequence.title === 'string' && sequence.title.length > 0;
}
